Merge branch 'wc/make-funnynames-shared-lazy-prereq'
[git/git.git] / t / test-lib.sh
CommitLineData
c74c7203 1# Test framework for git. See t/README for usage.
e1970ce4
JH
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
3c8f12c9
JH
18# Test the binaries we have just built. The tests are kept in
19# t/ subdirectory and are run in 'trash directory' subdirectory.
20if test -z "$TEST_DIRECTORY"
21then
22 # We allow tests to override this, in case they want to run tests
23 # outside of t/, e.g. for running tests on the test library
24 # itself.
25 TEST_DIRECTORY=$(pwd)
85176d72
FC
26else
27 # ensure that TEST_DIRECTORY is an absolute path so that it
28 # is valid even if the current working directory is changed
29 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
3c8f12c9
JH
30fi
31if test -z "$TEST_OUTPUT_DIRECTORY"
32then
33 # Similarly, override this to store the test-results subdir
34 # elsewhere
35 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36fi
37GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
d0cc5796
JK
39# If we were built with ASAN, it may complain about leaks
40# of program-lifetime variables. Disable it by default to lower
41# the noise level. This needs to happen at the start of the script,
42# before we even do our "did we build git yet" check (since we don't
43# want that one to complain to stderr).
bf1ce904 44: ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
d0cc5796
JK
45export ASAN_OPTIONS
46
85b81b35
JK
47# If LSAN is in effect we _do_ want leak checking, but we still
48# want to abort so that we notice the problems.
49: ${LSAN_OPTIONS=abort_on_error=1}
50export LSAN_OPTIONS
51
2006f0ad
RR
52################################################################
53# It appears that people try to run tests without building...
54"$GIT_BUILD_DIR/git" >/dev/null
55if test $? != 1
56then
57 echo >&2 'error: you do not seem to have built git yet.'
58 exit 1
59fi
60
3c8f12c9
JH
61. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
62export PERL_PATH SHELL_PATH
63
4cde519f
RR
64# if --tee was passed, write the output not only to the terminal, but
65# additionally to the file test-results/$BASENAME.out, too.
66case "$GIT_TEST_TEE_STARTED, $* " in
67done,*)
68 # do not redirect again
69 ;;
452320f1 70*' --tee '*|*' --va'*|*' --verbose-log '*)
2d14e13c
JK
71 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
72 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
452320f1
JK
73
74 # Make this filename available to the sub-process in case it is using
75 # --verbose-log.
76 GIT_TEST_TEE_OUTPUT_FILE=$BASE.out
77 export GIT_TEST_TEE_OUTPUT_FILE
78
79 # Truncate before calling "tee -a" to get rid of the results
80 # from any previous runs.
81 >"$GIT_TEST_TEE_OUTPUT_FILE"
82
3f824e91 83 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
452320f1 84 echo $? >"$BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
925bdc92 85 test "$(cat "$BASE.exit")" = 0
4cde519f
RR
86 exit
87 ;;
88esac
89
e1970ce4 90# For repeatability, reset the environment to known value.
d5c1b7c2 91# TERM is sanitized below, after saving color control sequences.
e1970ce4 92LANG=C
899460f3 93LC_ALL=C
d9bdd39e 94PAGER=cat
e1970ce4 95TZ=UTC
d5c1b7c2 96export LANG LC_ALL PAGER TZ
8ff99e74 97EDITOR=:
661bfd13
SL
98# A call to "unset" with no arguments causes at least Solaris 10
99# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
100# deriving from the command substitution clustered with the other
101# ones.
3c8f12c9 102unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 103 my @env = keys %ENV;
730477f1
JL
104 my $ok = join("|", qw(
105 TRACE
106 DEBUG
730477f1
JL
107 TEST
108 .*_TEST
109 PROVE
110 VALGRIND
ac001282 111 UNZIP
edb54081 112 PERF_
e2a0ccc0 113 CURL_VERBOSE
4527aa10 114 TRACE_CURL
730477f1
JL
115 ));
116 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
117 print join("\n", @vars);
118')
7976e901 119unset XDG_CACHE_HOME
5adf84eb 120unset XDG_CONFIG_HOME
8bade1e1 121unset GITPERLLIB
29e55cd5
JH
122GIT_AUTHOR_EMAIL=author@example.com
123GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
124GIT_COMMITTER_EMAIL=committer@example.com
125GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 126GIT_MERGE_VERBOSITY=5
f8246281
JH
127GIT_MERGE_AUTOEDIT=no
128export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
129export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
130export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 131export EDITOR
e1970ce4 132
124647c4
KB
133# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
134GIT_TRACE_BARE=1
135export GIT_TRACE_BARE
136
5d9fc888
TG
137if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
138then
139 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
140 export GIT_INDEX_VERSION
141fi
142
a731fa91
EP
143# Add libc MALLOC and MALLOC_PERTURB test
144# only if we are not executing the test with valgrind
1b3185fc 145if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
ee1431bf 146 test -n "$TEST_NO_MALLOC_CHECK"
1b3185fc
JH
147then
148 setup_malloc_check () {
149 : nothing
150 }
151 teardown_malloc_check () {
152 : nothing
153 }
154else
155 setup_malloc_check () {
156 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
157 export MALLOC_CHECK_ MALLOC_PERTURB_
158 }
159 teardown_malloc_check () {
160 unset MALLOC_CHECK_ MALLOC_PERTURB_
161 }
162fi
a731fa91 163
886a3907
JH
164# Protect ourselves from common misconfiguration to export
165# CDPATH into the environment
166unset CDPATH
167
5565f47c 168unset GREP_OPTIONS
ac001282 169unset UNZIP
5565f47c 170
3d5c0cc9 171case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756 1721|2|true)
025232e8 173 GIT_TRACE=4
1c0cc756 174 ;;
6ce4e61f
CC
175esac
176
cd3c095c
JH
177# Convenience
178#
5555a2aa 179# A regexp to match 5, 35 and 40 hexdigits
cd3c095c 180_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
5555a2aa
CB
181_x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
182_x40="$_x35$_x05"
cd3c095c 183
3749fde5
JH
184# Zero SHA-1
185_z40=0000000000000000000000000000000000000000
186
bd981d5f 187OID_REGEX="$_x40"
198857bf 188ZERO_OID=$_z40
f9e7d9f8 189EMPTY_TREE=4b825dc642cb6eb9a060e54bf8d69288fbee4904
378932d3 190EMPTY_BLOB=e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
f9e7d9f8 191
3f4ab627
JH
192# Line feed
193LF='
194'
195
a42643aa
JK
196# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
197# when case-folding filenames
198u200c=$(printf '\342\200\214')
199
bd981d5f 200export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
342e9ef2 201
e1970ce4
JH
202# Each test should start with something like this, after copyright notices:
203#
204# test_description='Description of this test...
205# This test checks if command xyzzy does the right thing...
206# '
207# . ./test-lib.sh
d5c1b7c2 208test "x$TERM" != "xdumb" && (
ca92a660
RH
209 test -t 1 &&
210 tput bold >/dev/null 2>&1 &&
211 tput setaf 1 >/dev/null 2>&1 &&
212 tput sgr0 >/dev/null 2>&1
213 ) &&
214 color=t
e1970ce4 215
e1970ce4
JH
216while test "$#" -ne 0
217do
218 case "$1" in
219 -d|--d|--de|--deb|--debu|--debug)
220 debug=t; shift ;;
886856ab
JH
221 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
222 immediate=t; shift ;;
5e2c08c6 223 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 224 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
0445e6f0
IB
225 -r)
226 shift; test "$#" -ne 0 || {
227 echo 'error: -r requires an argument' >&2;
228 exit 1;
229 }
230 run_list=$1; shift ;;
231 --run=*)
0ff74101 232 run_list=${1#--*=}; shift ;;
e1970ce4 233 -h|--h|--he|--hel|--help)
570f3226 234 help=t; shift ;;
e1970ce4
JH
235 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
236 verbose=t; shift ;;
ff09af3f 237 --verbose-only=*)
0ff74101 238 verbose_only=${1#--*=}
ff09af3f 239 shift ;;
1ece1274 240 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
241 # Ignore --quiet under a TAP::Harness. Saying how many tests
242 # passed without the ok/not ok details is always an error.
243 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
244 --with-dashes)
245 with_dashes=t; shift ;;
55db1df0 246 --no-color)
faa4bc35 247 color=; shift ;;
4e1be63c 248 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
952af351
TR
249 valgrind=memcheck
250 shift ;;
251 --valgrind=*)
0ff74101 252 valgrind=${1#--*=}
952af351 253 shift ;;
5dfc368f 254 --valgrind-only=*)
0ff74101 255 valgrind_only=${1#--*=}
5dfc368f 256 shift ;;
44138559
JS
257 --tee)
258 shift ;; # was handled already
f423ef5f 259 --root=*)
0ff74101 260 root=${1#--*=}
f423ef5f 261 shift ;;
bb79af9d
JK
262 --chain-lint)
263 GIT_TEST_CHAIN_LINT=1
264 shift ;;
265 --no-chain-lint)
266 GIT_TEST_CHAIN_LINT=0
267 shift ;;
a136f6d8 268 -x)
5fc98e79
SG
269 # Some test scripts can't be reliably traced with '-x',
270 # unless the test is run with a Bash version supporting
271 # BASH_XTRACEFD (introduced in Bash v4.1). Check whether
272 # this test is marked as such, and ignore '-x' if it
273 # isn't executed with a suitable Bash version.
274 if test -z "$test_untraceable" || {
275 test -n "$BASH_VERSION" && {
276 test ${BASH_VERSINFO[0]} -gt 4 || {
277 test ${BASH_VERSINFO[0]} -eq 4 &&
278 test ${BASH_VERSINFO[1]} -ge 1
279 }
280 }
281 }
282 then
283 trace=t
284 else
285 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
286 fi
a136f6d8 287 shift ;;
452320f1
JK
288 --verbose-log)
289 verbose_log=t
290 shift ;;
e1970ce4 291 *)
1f729dca 292 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
293 esac
294done
295
26a07309 296if test -n "$valgrind_only"
5dfc368f
TR
297then
298 test -z "$valgrind" && valgrind=memcheck
299 test -z "$verbose" && verbose_only="$valgrind_only"
300elif test -n "$valgrind"
301then
88c6e9d3 302 test -z "$verbose_log" && verbose=t
5dfc368f 303fi
952af351 304
f5ba2de6
JK
305if test -n "$trace" && test -z "$verbose_log"
306then
307 verbose=t
308fi
309
ca92a660
RH
310if test -n "$color"
311then
d5c1b7c2
RH
312 # Save the color control sequences now rather than run tput
313 # each time say_color() is called. This is done for two
314 # reasons:
315 # * TERM will be changed to dumb
316 # * HOME will be changed to a temporary directory and tput
317 # might need to read ~/.terminfo from the original HOME
318 # directory to get the control sequences
319 # Note: This approach assumes the control sequences don't end
320 # in a newline for any terminal of interest (command
321 # substitutions strip trailing newlines). Given that most
322 # (all?) terminals in common use are related to ECMA-48, this
323 # shouldn't be a problem.
324 say_color_error=$(tput bold; tput setaf 1) # bold red
325 say_color_skip=$(tput setaf 4) # blue
326 say_color_warn=$(tput setaf 3) # brown/yellow
327 say_color_pass=$(tput setaf 2) # green
328 say_color_info=$(tput setaf 6) # cyan
329 say_color_reset=$(tput sgr0)
330 say_color_="" # no formatting for normal text
ca92a660 331 say_color () {
d5c1b7c2
RH
332 test -z "$1" && test -n "$quiet" && return
333 eval "say_color_color=\$say_color_$1"
ca92a660 334 shift
d5c1b7c2 335 printf "%s\\n" "$say_color_color$*$say_color_reset"
ca92a660
RH
336 }
337else
338 say_color() {
339 test -z "$1" && test -n "$quiet" && return
340 shift
341 printf "%s\n" "$*"
342 }
343fi
344
d5c1b7c2
RH
345TERM=dumb
346export TERM
347
55db1df0
PH
348error () {
349 say_color error "error: $*"
6e7b5aaf 350 GIT_EXIT_OK=t
55db1df0
PH
351 exit 1
352}
353
354say () {
355 say_color info "$*"
356}
357
614fe015
JK
358if test -n "$HARNESS_ACTIVE"
359then
360 if test "$verbose" = t || test -n "$verbose_only"
361 then
362 printf 'Bail out! %s\n' \
363 'verbose mode forbidden under TAP harness; try --verbose-log'
364 exit 1
365 fi
366fi
367
570f3226
MB
368test "${test_description}" != "" ||
369error "Test script did not set test_description."
370
371if test "$help" = "t"
372then
cb1aefda 373 printf '%s\n' "$test_description"
570f3226
MB
374 exit 0
375fi
376
4d9d62fa 377exec 5>&1
781f76b1 378exec 6<&0
4ecae3c8 379exec 7>&2
452320f1
JK
380if test "$verbose_log" = "t"
381then
382 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
383elif test "$verbose" = "t"
e1970ce4
JH
384then
385 exec 4>&2 3>&1
386else
387 exec 4>/dev/null 3>/dev/null
388fi
389
d88785e4
JK
390# Send any "-x" output directly to stderr to avoid polluting tests
391# which capture stderr. We can do this unconditionally since it
392# has no effect if tracing isn't turned on.
393#
394# Note that this sets up the trace fd as soon as we assign the variable, so it
395# must come after the creation of descriptor 4 above. Likewise, we must never
396# unset this, as it has the side effect of closing descriptor 4, which we
397# use to show verbose tests to the user.
398#
399# Note also that we don't need or want to export it. The tracing is local to
400# this shell, and we would not want to influence any shells we exec.
401BASH_XTRACEFD=4
402
e1970ce4
JH
403test_failure=0
404test_count=0
41ac414e
JH
405test_fixed=0
406test_broken=0
2d84e9fb 407test_success=0
e1970ce4 408
d998bd4a
ÆAB
409test_external_has_tap=0
410
faa4bc35 411die () {
6e7b5aaf
CB
412 code=$?
413 if test -n "$GIT_EXIT_OK"
414 then
415 exit $code
416 else
417 echo >&5 "FATAL: Unexpected exit with code $code"
418 exit 1
419 fi
faa4bc35
CB
420}
421
6e7b5aaf 422GIT_EXIT_OK=
35641310 423trap 'die' EXIT
da706545 424trap 'exit $?' INT
41184273 425
12a29b1a
TR
426# The user-facing functions are loaded from a separate file so that
427# test_perf subshells can have them too
3c8f12c9 428. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 429
886856ab 430# You are not expected to call test_ok_ and test_failure_ directly, use
3fa36666 431# the test_expect_* functions instead.
886856ab
JH
432
433test_ok_ () {
d5d9de1b 434 test_success=$(($test_success + 1))
633fe50a 435 say_color "" "ok $test_count - $@"
e1970ce4
JH
436}
437
886856ab 438test_failure_ () {
d5d9de1b 439 test_failure=$(($test_failure + 1))
633fe50a 440 say_color error "not ok $test_count - $1"
bf0dd8a8 441 shift
cb1aefda 442 printf '%s\n' "$*" | sed -e 's/^/# /'
6e7b5aaf 443 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
444}
445
41ac414e 446test_known_broken_ok_ () {
41ac414e 447 test_fixed=$(($test_fixed+1))
633fe50a 448 say_color error "ok $test_count - $@ # TODO known breakage vanished"
41ac414e
JH
449}
450
451test_known_broken_failure_ () {
41ac414e 452 test_broken=$(($test_broken+1))
633fe50a 453 say_color warn "not ok $test_count - $@ # TODO known breakage"
41ac414e 454}
886856ab
JH
455
456test_debug () {
8e832ebc 457 test "$debug" = "" || eval "$1"
e1970ce4
JH
458}
459
e6a6ddc9
TR
460match_pattern_list () {
461 arg="$1"
462 shift
463 test -z "$*" && return 1
464 for pattern_
465 do
466 case "$arg" in
467 $pattern_)
468 return 0
469 esac
470 done
471 return 1
472}
473
0445e6f0
IB
474match_test_selector_list () {
475 title="$1"
476 shift
477 arg="$1"
478 shift
479 test -z "$1" && return 0
480
481 # Both commas and whitespace are accepted as separators.
482 OLDIFS=$IFS
483 IFS=' ,'
484 set -- $1
485 IFS=$OLDIFS
486
487 # If the first selector is negative we include by default.
488 include=
489 case "$1" in
490 !*) include=t ;;
491 esac
492
493 for selector
494 do
495 orig_selector=$selector
496
497 positive=t
498 case "$selector" in
499 !*)
500 positive=
501 selector=${selector##?}
502 ;;
503 esac
504
505 test -z "$selector" && continue
506
507 case "$selector" in
508 *-*)
509 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
510 then
511 echo "error: $title: invalid non-numeric in range" \
512 "start: '$orig_selector'" >&2
513 exit 1
514 fi
515 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
516 then
517 echo "error: $title: invalid non-numeric in range" \
518 "end: '$orig_selector'" >&2
519 exit 1
520 fi
521 ;;
522 *)
523 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
524 then
525 echo "error: $title: invalid non-numeric in test" \
526 "selector: '$orig_selector'" >&2
527 exit 1
528 fi
529 esac
530
531 # Short cut for "obvious" cases
532 test -z "$include" && test -z "$positive" && continue
533 test -n "$include" && test -n "$positive" && continue
534
535 case "$selector" in
536 -*)
537 if test $arg -le ${selector#-}
538 then
539 include=$positive
540 fi
541 ;;
542 *-)
543 if test $arg -ge ${selector%-}
544 then
545 include=$positive
546 fi
547 ;;
548 *-*)
549 if test ${selector%%-*} -le $arg \
550 && test $arg -le ${selector#*-}
551 then
552 include=$positive
553 fi
554 ;;
555 *)
556 if test $arg -eq $selector
557 then
558 include=$positive
559 fi
560 ;;
561 esac
562 done
563
564 test -n "$include"
565}
566
ff09af3f
TR
567maybe_teardown_verbose () {
568 test -z "$verbose_only" && return
569 exec 4>/dev/null 3>/dev/null
570 verbose=
571}
572
573last_verbose=t
574maybe_setup_verbose () {
575 test -z "$verbose_only" && return
26a07309 576 if match_pattern_list $test_count $verbose_only
ff09af3f
TR
577 then
578 exec 4>&2 3>&1
579 # Emit a delimiting blank line when going from
580 # non-verbose to verbose. Within verbose mode the
581 # delimiter is printed by test_expect_*. The choice
582 # of the initial $last_verbose is such that before
583 # test 1, we do not print it.
584 test -z "$last_verbose" && echo >&3 ""
585 verbose=t
586 else
587 exec 4>/dev/null 3>/dev/null
588 verbose=
589 fi
590 last_verbose=$verbose
591}
592
5dfc368f
TR
593maybe_teardown_valgrind () {
594 test -z "$GIT_VALGRIND" && return
595 GIT_VALGRIND_ENABLED=
596}
597
598maybe_setup_valgrind () {
599 test -z "$GIT_VALGRIND" && return
26a07309 600 if test -z "$valgrind_only"
5dfc368f
TR
601 then
602 GIT_VALGRIND_ENABLED=t
603 return
604 fi
605 GIT_VALGRIND_ENABLED=
606 if match_pattern_list $test_count $valgrind_only
607 then
608 GIT_VALGRIND_ENABLED=t
609 fi
610}
611
9b5fe78b 612want_trace () {
f5ba2de6
JK
613 test "$trace" = t && {
614 test "$verbose" = t || test "$verbose_log" = t
615 }
9b5fe78b
JK
616}
617
a136f6d8
JK
618# This is a separate function because some tests use
619# "return" to end a test_expect_success block early
620# (and we want to make sure we run any cleanup like
621# "set +x").
622test_eval_inner_ () {
623 # Do not add anything extra (including LF) after '$*'
624 eval "
9b5fe78b 625 want_trace && set -x
a136f6d8
JK
626 $*"
627}
628
a7c58f28 629test_eval_ () {
90c8a1db
JK
630 # If "-x" tracing is in effect, then we want to avoid polluting stderr
631 # with non-test commands. But once in "set -x" mode, we cannot prevent
a136f6d8
JK
632 # the shell from printing the "set +x" to turn it off (nor the saving
633 # of $? before that). But we can make sure that the output goes to
634 # /dev/null.
635 #
90c8a1db
JK
636 # There are a few subtleties here:
637 #
638 # - we have to redirect descriptor 4 in addition to 2, to cover
639 # BASH_XTRACEFD
640 #
641 # - the actual eval has to come before the redirection block (since
642 # it needs to see descriptor 4 to set up its stderr)
643 #
644 # - likewise, any error message we print must be outside the block to
645 # access descriptor 4
646 #
647 # - checking $? has to come immediately after the eval, but it must
648 # be _inside_ the block to avoid polluting the "set -x" output
649 #
650
651 test_eval_inner_ "$@" </dev/null >&3 2>&4
a136f6d8 652 {
a136f6d8 653 test_eval_ret_=$?
9b5fe78b 654 if want_trace
a136f6d8
JK
655 then
656 set +x
a136f6d8 657 fi
90c8a1db
JK
658 } 2>/dev/null 4>&2
659
660 if test "$test_eval_ret_" != 0 && want_trace
661 then
662 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
663 fi
a136f6d8 664 return $test_eval_ret_
a7c58f28
JN
665}
666
4d9d62fa 667test_run_ () {
b6b0afdc 668 test_cleanup=:
b586744a 669 expecting_failure=$2
bb79af9d 670
92b269f5 671 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
2a01ef8c
JK
672 # turn off tracing for this test-eval, as it simply creates
673 # confusing noise in the "-x" output
674 trace_tmp=$trace
675 trace=
bb79af9d
JK
676 # 117 is magic because it is unlikely to match the exit
677 # code of other programs
878f9883
ES
678 if $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!') ||
679 test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
99a64e4b
JH
680 then
681 error "bug in the test script: broken &&-chain or run-away HERE-DOC: $1"
bb79af9d 682 fi
2a01ef8c 683 trace=$trace_tmp
bb79af9d
JK
684 fi
685
a57397b0 686 setup_malloc_check
a7c58f28 687 test_eval_ "$1"
b6b0afdc 688 eval_ret=$?
a57397b0 689 teardown_malloc_check
b586744a 690
a136f6d8
JK
691 if test -z "$immediate" || test $eval_ret = 0 ||
692 test -n "$expecting_failure" && test "$test_cleanup" != ":"
b586744a 693 then
1b3185fc 694 setup_malloc_check
a7c58f28 695 test_eval_ "$test_cleanup"
1b3185fc 696 teardown_malloc_check
b586744a 697 fi
1c0cc756
RJ
698 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
699 then
57e1538a
ÆAB
700 echo ""
701 fi
aa0bcf96 702 return "$eval_ret"
4d9d62fa
PR
703}
704
ae75342c 705test_start_ () {
8586f98b 706 test_count=$(($test_count+1))
ff09af3f 707 maybe_setup_verbose
5dfc368f 708 maybe_setup_valgrind
ae75342c
TR
709}
710
711test_finish_ () {
712 echo >&3 ""
5dfc368f 713 maybe_teardown_valgrind
ff09af3f 714 maybe_teardown_verbose
ae75342c
TR
715}
716
717test_skip () {
04ece593 718 to_skip=
ef2ac68d 719 skipped_reason=
e6a6ddc9
TR
720 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
721 then
722 to_skip=t
ef2ac68d 723 skipped_reason="GIT_SKIP_TESTS"
e6a6ddc9 724 fi
05236a5e
JN
725 if test -z "$to_skip" && test -n "$test_prereq" &&
726 ! test_have_prereq "$test_prereq"
a7bb3940
JS
727 then
728 to_skip=t
ef2ac68d 729
07431fc8 730 of_prereq=
05236a5e 731 if test "$missing_prereq" != "$test_prereq"
07431fc8 732 then
05236a5e 733 of_prereq=" of $test_prereq"
07431fc8 734 fi
ef2ac68d
IB
735 skipped_reason="missing $missing_prereq${of_prereq}"
736 fi
0445e6f0
IB
737 if test -z "$to_skip" && test -n "$run_list" &&
738 ! match_test_selector_list '--run' $test_count "$run_list"
739 then
740 to_skip=t
741 skipped_reason="--run"
742 fi
07431fc8 743
ef2ac68d
IB
744 case "$to_skip" in
745 t)
633fe50a 746 say_color skip >&3 "skipping test: $@"
ef2ac68d 747 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
04ece593
JH
748 : true
749 ;;
750 *)
751 false
752 ;;
753 esac
754}
755
342e9ef2
TR
756# stub; perf-lib overrides it
757test_at_end_hook_ () {
758 :
759}
760
e1970ce4 761test_done () {
6e7b5aaf 762 GIT_EXIT_OK=t
2d84e9fb 763
1c0cc756
RJ
764 if test -z "$HARNESS_ACTIVE"
765 then
342e9ef2 766 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
8ef1abe5 767 mkdir -p "$test_results_dir"
dd78478f 768 base=${0##*/}
5c885c1b 769 test_results_path="$test_results_dir/${base%.sh}.counts"
8ef1abe5 770
5c885c1b 771 cat >"$test_results_path" <<-EOF
c54e6be7
ML
772 total $test_count
773 success $test_success
774 fixed $test_fixed
775 broken $test_broken
776 failed $test_failure
777
778 EOF
8ef1abe5 779 fi
41ac414e
JH
780
781 if test "$test_fixed" != 0
782 then
633fe50a 783 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
41ac414e
JH
784 fi
785 if test "$test_broken" != 0
786 then
633fe50a 787 say_color warn "# still have $test_broken known breakage(s)"
b73d9a23
AS
788 fi
789 if test "$test_broken" != 0 || test "$test_fixed" != 0
790 then
791 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
792 msg="remaining $test_remaining test(s)"
11d54b8b 793 else
b73d9a23 794 test_remaining=$test_count
11d54b8b 795 msg="$test_count test(s)"
41ac414e 796 fi
e1970ce4 797 case "$test_failure" in
10b94e28 798 0)
1c0cc756
RJ
799 if test $test_external_has_tap -eq 0
800 then
b73d9a23 801 if test $test_remaining -gt 0
d87bd7c1 802 then
633fe50a 803 say_color pass "# passed all $msg"
d87bd7c1 804 fi
c7018be5
JH
805
806 # Maybe print SKIP message
807 test -z "$skip_all" || skip_all="# SKIP $skip_all"
808 case "$test_count" in
809 0)
810 say "1..$test_count${skip_all:+ $skip_all}"
811 ;;
812 *)
813 test -z "$skip_all" ||
814 say_color warn "$skip_all"
815 say "1..$test_count"
816 ;;
817 esac
d998bd4a 818 fi
abc5d372 819
06478dab 820 if test -z "$debug"
4d0912a2 821 then
06478dab 822 test -d "$TRASH_DIRECTORY" ||
4d0912a2 823 error "Tests passed but trash directory already removed before test cleanup; aborting"
abc5d372 824
06478dab
JH
825 cd "$TRASH_DIRECTORY/.." &&
826 rm -fr "$TRASH_DIRECTORY" ||
4d0912a2 827 error "Tests passed but test cleanup failed; aborting"
4d0912a2 828 fi
342e9ef2
TR
829 test_at_end_hook_
830
e1970ce4
JH
831 exit 0 ;;
832
833 *)
1c0cc756
RJ
834 if test $test_external_has_tap -eq 0
835 then
633fe50a
TR
836 say_color error "# failed $test_failure among $msg"
837 say "1..$test_count"
d998bd4a 838 fi
5099b99d 839
e1970ce4
JH
840 exit 1 ;;
841
842 esac
843}
844
e4597aae 845if test -n "$valgrind"
4e1be63c 846then
4e1be63c
JS
847 make_symlink () {
848 test -h "$2" &&
849 test "$1" = "$(readlink "$2")" || {
850 # be super paranoid
851 if mkdir "$2".lock
852 then
853 rm -f "$2" &&
854 ln -s "$1" "$2" &&
855 rm -r "$2".lock
856 else
857 while test -d "$2".lock
858 do
859 say "Waiting for lock on $2."
860 sleep 1
861 done
862 fi
863 }
864 }
865
866 make_valgrind_symlink () {
36bfb0e5 867 # handle only executables, unless they are shell libraries that
11d62145 868 # need to be in the exec-path.
36bfb0e5 869 test -x "$1" ||
11d62145 870 test "# " = "$(head -c 2 <"$1")" ||
36bfb0e5 871 return;
4e1be63c
JS
872
873 base=$(basename "$1")
28fab7b2
RS
874 case "$base" in
875 test-*)
876 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
877 ;;
878 *)
879 symlink_target="$GIT_BUILD_DIR/$base"
880 ;;
881 esac
4e1be63c
JS
882 # do not override scripts
883 if test -x "$symlink_target" &&
884 test ! -d "$symlink_target" &&
885 test "#!" != "$(head -c 2 < "$symlink_target")"
886 then
887 symlink_target=../valgrind.sh
888 fi
efd92ffd
JS
889 case "$base" in
890 *.sh|*.perl)
891 symlink_target=../unprocessed-script
892 esac
4e1be63c
JS
893 # create the link, or replace it if it is out of date
894 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
895 }
896
26a07309
TR
897 # override all git executables in TEST_DIRECTORY/..
898 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
899 mkdir -p "$GIT_VALGRIND"/bin
503e2241 900 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
26a07309
TR
901 do
902 make_valgrind_symlink $file
903 done
904 # special-case the mergetools loadables
905 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
906 OLDIFS=$IFS
907 IFS=:
908 for path in $PATH
909 do
910 ls "$path"/git-* 2> /dev/null |
911 while read file
ad0e6233 912 do
26a07309 913 make_valgrind_symlink "$file"
ad0e6233 914 done
26a07309
TR
915 done
916 IFS=$OLDIFS
4e1be63c
JS
917 PATH=$GIT_VALGRIND/bin:$PATH
918 GIT_EXEC_PATH=$GIT_VALGRIND/bin
919 export GIT_VALGRIND
952af351
TR
920 GIT_VALGRIND_MODE="$valgrind"
921 export GIT_VALGRIND_MODE
5dfc368f 922 GIT_VALGRIND_ENABLED=t
26a07309 923 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
5dfc368f 924 export GIT_VALGRIND_ENABLED
1c0cc756
RJ
925elif test -n "$GIT_TEST_INSTALLED"
926then
e4597aae
MO
927 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
928 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 929 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
930 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
931else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 932 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1c0cc756
RJ
933 if ! test -x "$git_bin_dir/git"
934 then
935 if test -z "$with_dashes"
936 then
e4597aae
MO
937 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
938 fi
939 with_dashes=t
940 fi
941 PATH="$git_bin_dir:$PATH"
6cec5c68 942 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
943 if test -n "$with_dashes"
944 then
6cec5c68 945 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 946 fi
4e1be63c 947fi
6cec5c68 948GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 949GIT_CONFIG_NOSYSTEM=1
3c995beb 950GIT_ATTR_NOSYSTEM=1
8f323c00 951export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 952
5e87eae9
JH
953if test -z "$GIT_TEST_CMP"
954then
955 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
956 then
957 GIT_TEST_CMP="$DIFF -c"
958 else
959 GIT_TEST_CMP="$DIFF -u"
960 fi
961fi
962
20d2a30f 963GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
6fcca938 964export GITPERLLIB
6cec5c68 965test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
966 error "You haven't built things yet, have you?"
967}
e1970ce4 968
0e496492 969if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool
1c0cc756 970then
0e496492
NTND
971 echo >&2 'You need to build test-tool:'
972 echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
56cf9806
EW
973 exit 1
974fi
975
e1970ce4 976# Test repository
002d4ce8
JK
977TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
978test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
979case "$TRASH_DIRECTORY" in
980/*) ;; # absolute path is good
981 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
f423ef5f 982esac
38b074de 983rm -fr "$TRASH_DIRECTORY" || {
6e7b5aaf 984 GIT_EXIT_OK=t
8d14ac94
JH
985 echo >&5 "FATAL: Cannot prepare test area"
986 exit 1
987}
988
90cff968 989HOME="$TRASH_DIRECTORY"
0ea47f9d
JH
990GNUPGHOME="$HOME/gnupg-home-not-used"
991export HOME GNUPGHOME
90cff968 992
1c0cc756
RJ
993if test -z "$TEST_NO_CREATE_REPO"
994then
38b074de 995 test_create_repo "$TRASH_DIRECTORY"
342e9ef2 996else
38b074de 997 mkdir -p "$TRASH_DIRECTORY"
342e9ef2 998fi
1bd9c648
LW
999# Use -P to resolve symlinks in our working directory so that the cwd
1000# in subprocesses like git equals our $PWD (for pathname comparisons).
38b074de 1001cd -P "$TRASH_DIRECTORY" || exit 1
04ece593 1002
d5d9de1b
JS
1003this_test=${0##*/}
1004this_test=${this_test%%-*}
e6a6ddc9
TR
1005if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1006then
1007 say_color info >&3 "skipping test $this_test altogether"
1008 skip_all="skip all tests in $this_test"
1009 test_done
1010fi
f17e9fbb 1011
8648732e
BC
1012# Provide an implementation of the 'yes' utility
1013yes () {
1014 if test $# = 0
1015 then
1016 y=y
1017 else
1018 y="$*"
1019 fi
1020
6129c930
JS
1021 i=0
1022 while test $i -lt 99
8648732e 1023 do
6129c930
JS
1024 echo "$y"
1025 i=$(($i+1))
8648732e
BC
1026 done
1027}
1028
f17e9fbb 1029# Fix some commands on Windows
d98b2c5f
JS
1030uname_s=$(uname -s)
1031case $uname_s in
f17e9fbb
JS
1032*MINGW*)
1033 # Windows has its own (incompatible) sort and find
1034 sort () {
1035 /usr/bin/sort "$@"
1036 }
1037 find () {
1038 /usr/bin/find "$@"
1039 }
4114156a
JS
1040 # git sees Windows-style pwd
1041 pwd () {
1042 builtin pwd -W
1043 }
ee9fb68c 1044 # no POSIX permissions
6fd1106a 1045 # backslashes in pathspec are converted to '/'
fb9a2bea 1046 # exec does not inherit the PID
a94114ad 1047 test_set_prereq MINGW
5f4e02e5 1048 test_set_prereq NATIVE_CRLF
a31d0665 1049 test_set_prereq SED_STRIPS_CR
97669eed 1050 test_set_prereq GREP_STRIPS_CR
4d715ac0 1051 GIT_TEST_CMP=mingw_test_cmp
a31d0665
RJ
1052 ;;
1053*CYGWIN*)
1054 test_set_prereq POSIXPERM
a31d0665 1055 test_set_prereq EXECKEEPSPID
cfa96496 1056 test_set_prereq CYGWIN
a31d0665 1057 test_set_prereq SED_STRIPS_CR
97669eed 1058 test_set_prereq GREP_STRIPS_CR
ee9fb68c
JS
1059 ;;
1060*)
1061 test_set_prereq POSIXPERM
6fd1106a 1062 test_set_prereq BSLASHPSPEC
fb9a2bea 1063 test_set_prereq EXECKEEPSPID
f17e9fbb
JS
1064 ;;
1065esac
704a3143 1066
b082687c 1067( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 1068test -z "$NO_PERL" && test_set_prereq PERL
68c7d276 1069test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
d4e1b47a 1070test -z "$NO_PYTHON" && test_set_prereq PYTHON
94da9193 1071test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
ce9a2570
ÆAB
1072test -n "$USE_LIBPCRE1" && test_set_prereq LIBPCRE1
1073test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
5e9637c6 1074test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 1075
bb946bba 1076# Can we rely on git's output in the C locale?
30955229
JN
1077if test -n "$GETTEXT_POISON"
1078then
1079 GIT_GETTEXT_POISON=YesPlease
1080 export GIT_GETTEXT_POISON
5e9637c6 1081 test_set_prereq GETTEXT_POISON
30955229
JN
1082else
1083 test_set_prereq C_LOCALE_OUTPUT
1084fi
bb946bba 1085
20073274
AS
1086test_lazy_prereq PIPE '
1087 # test whether the filesystem supports FIFOs
7b7bea23
RJ
1088 test_have_prereq !MINGW,!CYGWIN &&
1089 rm -f testfifo && mkfifo testfifo
20073274
AS
1090'
1091
04083f27
JH
1092test_lazy_prereq SYMLINKS '
1093 # test whether the filesystem supports symbolic links
1094 ln -s x y && test -h y
1095'
c91cfd19 1096
b018c735
JN
1097test_lazy_prereq FILEMODE '
1098 test "$(git config --bool core.filemode)" = true
1099'
1100
ac39aa61
MG
1101test_lazy_prereq CASE_INSENSITIVE_FS '
1102 echo good >CamelCase &&
1103 echo bad >camelcase &&
1104 test "$(cat CamelCase)" != good
1105'
1106
6ec63305
WC
1107test_lazy_prereq FUNNYNAMES '
1108 test_have_prereq !MINGW &&
1109 touch -- \
1110 "FUNNYNAMES tab embedded" \
1111 "FUNNYNAMES \"quote embedded\"" \
1112 "FUNNYNAMES newline
1113embedded" 2>/dev/null &&
1114 rm -- \
1115 "FUNNYNAMES tab embedded" \
1116 "FUNNYNAMES \"quote embedded\"" \
1117 "FUNNYNAMES newline
1118embedded" 2>/dev/null
1119'
1120
5b0b5dd4
MG
1121test_lazy_prereq UTF8_NFD_TO_NFC '
1122 # check whether FS converts nfd unicode to nfc
1123 auml=$(printf "\303\244")
1124 aumlcdiar=$(printf "\141\314\210")
1125 >"$auml" &&
742ae10e 1126 test -f "$aumlcdiar"
5b0b5dd4
MG
1127'
1128
09feffb6
JK
1129test_lazy_prereq AUTOIDENT '
1130 sane_unset GIT_AUTHOR_NAME &&
1131 sane_unset GIT_AUTHOR_EMAIL &&
1132 git var GIT_AUTHOR_IDENT
1133'
1134
6219bb22
JH
1135test_lazy_prereq EXPENSIVE '
1136 test -n "$GIT_TEST_LONG"
1137'
1138
5b1fe6eb
ÆAB
1139test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1140 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1141'
1142
e1ecd9e3
JH
1143test_lazy_prereq USR_BIN_TIME '
1144 test -x /usr/bin/time
1145'
1146
1767c517
JK
1147test_lazy_prereq NOT_ROOT '
1148 uid=$(id -u) &&
1149 test "$uid" != 0
1150'
1151
63b747ce
JT
1152test_lazy_prereq JGIT '
1153 type jgit
1154'
1155
719c3da2
JH
1156# SANITY is about "can you correctly predict what the filesystem would
1157# do by only looking at the permission bits of the files and
1158# directories?" A typical example of !SANITY is running the test
1159# suite as root, where a test may expect "chmod -r file && cat file"
1160# to fail because file is supposed to be unreadable after a successful
1161# chmod. In an environment (i.e. combination of what filesystem is
1162# being used and who is running the tests) that lacks SANITY, you may
1163# be able to delete or create a file when the containing directory
1164# doesn't have write permissions, or access a file even if the
1165# containing directory doesn't have read or execute permissions.
1166
f400e51c
TB
1167test_lazy_prereq SANITY '
1168 mkdir SANETESTD.1 SANETESTD.2 &&
1169
1170 chmod +w SANETESTD.1 SANETESTD.2 &&
1171 >SANETESTD.1/x 2>SANETESTD.2/x &&
1172 chmod -w SANETESTD.1 &&
719c3da2 1173 chmod -r SANETESTD.1/x &&
f400e51c
TB
1174 chmod -rx SANETESTD.2 ||
1175 error "bug in test sript: cannot prepare SANETESTD"
1176
719c3da2 1177 ! test -r SANETESTD.1/x &&
f400e51c
TB
1178 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1179 status=$?
1180
1181 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1182 rm -rf SANETESTD.1 SANETESTD.2 ||
1183 error "bug in test sript: cannot clean SANETESTD"
1184 return $status
1185'
f838ce58 1186
d98b2c5f 1187test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
f838ce58
JK
1188GIT_UNZIP=${GIT_UNZIP:-unzip}
1189test_lazy_prereq UNZIP '
1190 "$GIT_UNZIP" -v
1191 test $? -ne 127
1192'
9a308de3
JK
1193
1194run_with_limited_cmdline () {
1195 (ulimit -s 128 && "$@")
1196}
1197
21dac1de
RJ
1198test_lazy_prereq CMDLINE_LIMIT '
1199 test_have_prereq !MINGW,!CYGWIN &&
1200 run_with_limited_cmdline true
1201'
6b9c38e1 1202
4db464f8
MG
1203run_with_limited_stack () {
1204 (ulimit -s 128 && "$@")
1205}
1206
21dac1de
RJ
1207test_lazy_prereq ULIMIT_STACK_SIZE '
1208 test_have_prereq !MINGW,!CYGWIN &&
1209 run_with_limited_stack true
1210'
4db464f8 1211
6b9c38e1
JK
1212build_option () {
1213 git version --build-options |
1214 sed -ne "s/^$1: //p"
1215}
1216
1217test_lazy_prereq LONG_IS_64BIT '
1218 test 8 -le "$(build_option sizeof-long)"
1219'
a07fb050 1220
a801a7cf
NTND
1221test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1222test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
e9184b07
JK
1223
1224test_lazy_prereq CURL '
1225 curl --version
1226'
d16ab634 1227
1228# SHA1 is a test if the hash algorithm in use is SHA-1. This is both for tests
1229# which will not work with other hash algorithms and tests that work but don't
1230# test anything meaningful (e.g. special values which cause short collisions).
1231test_lazy_prereq SHA1 '
1232 test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
1233'